#include <stdio.h>
#include <stdlib.h>
#include <bios.h>
#include <conio.h>
#include <dos.h>


#define xOffset 128
#define yOffset 50
// #define colorOffset 31
void screen(int t);
void PutPixel(int x, int y, char c);
char GetPixel(int x, int y);
void PutBmp(int x, int y, unsigned char *bitmap, int x_size, int y_size);
int loadthis(unsigned char *bmp, char *file);
unsigned char inkey(void);
void initplay(void);
void shuffle(void);
void update(int u);
void SelectFigure(int x3, int y3);
int checkwin(void);
void smoooth(int x1, int y1, int x2, int y2, int colorOffset);
int spelplan[4][4], x, y, x2, y2;
char siffror[10][8][8], blank[16][16];

void main(void)
{
	int board[4][4], xPos, yPos, q, temp;
	char *files[10], *blankpek = "rawfiler\\blank.raw", ch = 0;
	files[0] = "rawfiler\\0.raw";
	files[1] = "rawfiler\\1.raw";
	files[2] = "rawfiler\\2.raw";
	files[3] = "rawfiler\\3.raw";
	files[4] = "rawfiler\\4.raw";
	files[5] = "rawfiler\\5.raw";
	files[6] = "rawfiler\\6.raw";
	files[7] = "rawfiler\\7.raw";
	files[8] = "rawfiler\\8.raw";
	files[9] = "rawfiler\\9.raw";

	for(q = 0;q != 10;q++)
//		loadthis(&bmp[q][0][0], files[q]);
		if((loadthis(&siffror[q][0][0], files[q])) == -1)
		{
			clrscr();
			printf("Error opening %d.raw\n", q+1);
			while(!inkey());
		}
		if((loadthis(&blank[0][0], blankpek)) == -1)
		{
			clrscr();
			printf("Error opening blank.raw\n");
			while(!inkey());
		}
	randomize();
	initplay();
	shuffle();
	screen(0x13);
	printf("\n> Use arrow keys to control\n> Space to shuffle\n> [ESC] to quit");
	smoooth(0, 8, 319, 16, 39);
	smoooth(0, 16, 319, 24, 39);
	smoooth(0, 24, 319, 32, 39);
	update(0);
	while(ch != 27)
	{
		fflush(stdin);
		ch = inkey();
		if(ch)
		{
			if(ch == ' ')
				shuffle();
			if((ch == 80) && y != 0)
			{
				temp = spelplan[x][y];
				spelplan[x][y] = spelplan[x][y-1];
				spelplan[x][y-1] = temp;
				y2 = y;
				x2 = x;
				y--;
				update(1);
			}
			else if((ch == 72) && y != 3)
			{
				temp = spelplan[x][y];
				spelplan[x][y] = spelplan[x][y+1];
				spelplan[x][y+1] = temp;
				y2 = y;
				x2 = x;
				y++;
				update(1);
			}
			else if((ch == 77) && x != 0)
			{
				temp = spelplan[x][y];
				spelplan[x][y] = spelplan[x-1][y];
				spelplan[x-1][y] = temp;
				x2 = x;
				y2 = y;
				x--;
				update(1);
			}
			else if((ch == 75) && x != 3)
			{
				temp = spelplan[x][y];
				spelplan[x][y] = spelplan[x+1][y];
				spelplan[x+1][y] = temp;
				x2 = x;
				y2 = y;
				x++;
				update(1);
			}

/*			gotoxy(1, 2);
			printf("X: %d, Y: %d", x, y); */
			if(checkwin())
			{
				gotoxy(8, 16);
				printf("WOW, you solved the puzzle!");
				while((ch != 27) && (ch != ' '))
				{
					for(q = 0;q != 10;q++)
					{
						smoooth(56, 120, 319, 128, 44+q);
						delay(50);
//						ch = inkey();
					}
					for(q = 10;q != 0;q--)
					{
						smoooth(56, 120, 319, 128, 44+q);
						delay(50);
//						ch = inkey();
					}
					ch = inkey();
				}
				if(ch = ' ')
					shuffle();
				update(0);
			}
		}
	}
	screen(0x3);
	printf("Sliding-Puzzle by Andreas Remar -99");
}

int loadthis(unsigned char *bmp, char *file)
{
	FILE *load;
	int x, y, xmax, ymax;
	if((load = fopen(file, "r")) == NULL)
		return(-1);
	else
	{
		xmax = getc(load);
		ymax = getc(load);
		for(y = 0;y != ymax;y++)
			for(x = 0;x != xmax;x++)
				bmp[y*xmax+x] = getc(load);
	}
}

unsigned char inkey(void)
{
	if(kbhit()) //bioskey(1))
		return(getch());
	else
		return(0);
}

/*	if (kbhit()){brajja=getch();
	if (brajja==75)dir=1;
	if (brajja==77)dir=2;
	if (brajja==80)dir=3;
	if (brajja==72)dir=4;
	if (brajja==' ')putbang(shipx,shipy);
	if (brajja==27)exit(0);
	} */

/* === Initiera spelplanen === */

void initplay(void)
{
	int x, y;
	for(y = 0;y != 4;y++)
		for(x = 0;x != 4;x++)
			if(y*4+(x+1) != 16)
				spelplan[x][y] = y * 4 + (x+1);
			else
				spelplan[x][y] = 0;
}

/* === Bland spelplanen === */

void shuffle(void)
{
	int rnd, q, temp;
	initplay();
	x = 3; y = 3;
	for(q = 0;q != 500;q++)
	{
		rnd = random(4);
		if((rnd == 0) && y != 0)
		{
			temp = spelplan[x][y];
			spelplan[x][y] = spelplan[x][y-1];
			spelplan[x][y-1] = temp;
			y--;
			y2 = y;
		}
		if((rnd == 1) && y != 3)
		{
			temp = spelplan[x][y];
			spelplan[x][y] = spelplan[x][y+1];
			spelplan[x][y+1] = temp;
			y++;
			y2 = y;
		}
		if((rnd == 2) && x != 0)
		{
			temp = spelplan[x][y];
			spelplan[x][y] = spelplan[x-1][y];
			spelplan[x-1][y] = temp;
			x--;
			x2 = x;
		}
		if((rnd == 3) && x != 3)
		{
			temp = spelplan[x][y];
			spelplan[x][y] = spelplan[x+1][y];
			spelplan[x+1][y] = temp;
			x++;
			x2 = x;
		}
	}
	update(0);
}

/* === Uppdatera spelplanen (hela eller en del) === */
void update(int u)
{
	int x3, y3, x4, y4;
	if(u == 0)
	{
		gotoxy(1,16);
		for(x3 = 0;x3 != 40;x3++)
			printf(" ");
		for(y3 = 0;y3 != 4;y3++)
			for(x3 = 0;x3 != 4;x3++)
						if(spelplan[x3][y3] != 0)
						{
							PutBmp(x3 * 16 + xOffset, y3 * 16 + yOffset, &blank[0][0], 16, 16);
							SelectFigure(x3, y3);
						}
						else
						{
							for(y4 = 0;y4 != 16;y4++)
								for(x4 = 0;x4 != 16;x4++)
									PutPixel(x3 * 16 + xOffset + x4, y3 * 16 + yOffset + y4, 0);

						}
	}
	else
	{
//		gotoxy(1, 1);
//		printf("X: %d, Y: %d", x, y);
		PutBmp(x2 * 16 + xOffset, y2 * 16 + yOffset, &blank[0][0], 16, 16);
		SelectFigure(x2, y2);
		for(y4 = 0;y4 != 16;y4++)
			for(x4 = 0;x4 != 16;x4++)
				PutPixel(x * 16 + xOffset + x4, y * 16 + yOffset + y4, 0);
	}
}

void SelectFigure(int x3, int y3)
{
	switch(spelplan[x3][y3])
	{
		case 1:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8); break;
		case 2:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[2][0][0], 8, 8); break;
		case 3:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[3][0][0], 8, 8); break;
		case 4:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[4][0][0], 8, 8); break;
		case 5:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[5][0][0], 8, 8); break;
		case 6:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[6][0][0], 8, 8); break;
		case 7:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[7][0][0], 8, 8); break;
		case 8:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[8][0][0], 8, 8); break;
		case 9:PutBmp(x3 * 16 + xOffset + 4, y3 * 16 + yOffset + 4,&siffror[9][0][0], 8, 8); break;
		case 10:
			PutBmp(x3 * 16 + xOffset, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8);
			PutBmp(x3 * 16 + xOffset + 8, y3 * 16 + yOffset + 4,&siffror[0][0][0], 8, 8);
			break;
		case 11:
			PutBmp(x3 * 16 + xOffset, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8);
			PutBmp(x3 * 16 + xOffset + 8, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8);
			break;
		case 12:
			PutBmp(x3 * 16 + xOffset, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8);
			PutBmp(x3 * 16 + xOffset + 8, y3 * 16 + yOffset + 4,&siffror[2][0][0], 8, 8);
			break;
		case 13:
			PutBmp(x3 * 16 + xOffset, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8);
			PutBmp(x3 * 16 + xOffset + 8, y3 * 16 + yOffset + 4,&siffror[3][0][0], 8, 8);
			break;
		case 14:
			PutBmp(x3 * 16 + xOffset, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8);
			PutBmp(x3 * 16 + xOffset + 8, y3 * 16 + yOffset + 4,&siffror[4][0][0], 8, 8);
			break;
		case 15:
			PutBmp(x3 * 16 + xOffset, y3 * 16 + yOffset + 4,&siffror[1][0][0], 8, 8);
			PutBmp(x3 * 16 + xOffset + 8, y3 * 16 + yOffset + 4,&siffror[5][0][0], 8, 8);
			break;
	}

}

int checkwin(void)
{
	int q = 0, x1, y1;
	for(y1 = 0;y1 != 4;y1++)
		for(x1 = 0;x1 != 4;x1++)
			if(spelplan[x1][y1] == y1 * 4 + (x1+1))
				q++;
	if(q == 15)
		return(1);
	else
		return(0);
}

void smoooth(int x1, int y1, int x2, int y2, int colorOffset)
{
	int x, y;
	for(y = y1;y <= y2;y++)
		for(x = x1;x <= x2;x++)
			if(GetPixel(x, y) != 0)
				PutPixel(x, y, (y2-y) + colorOffset); //+ x % 16);
}

/************************************************************\
|*	for(x = 0;x != 5;x++)                                   *|
|*		PutBmp(x*16+100, 156, &blank[0][0], 16, 16);        *|
|*	for(x = 0;x != 10;x++)                                  *|
|*		PutBmp(x*8+100, 160, &siffror[x][0][0], 8, 8);      *|
\************************************************************/
